/*
  Author: Peter Gebruers, aka "petergebruers". You can meet me here:

  https://forum.fibaro.com/index.php?/profile/1799-petergebruers/
  or here:
  https://forum.z-wave.me/memberlist.php?mode=viewprofile&u=564463
  or here:
  https://community.home-assistant.io/u/petergebruers
*/

#include "Arduino.h"

// Setup channel using a variable (instead of getter/setter)
// works on FW >= 2.1.5 only

byte BinarySwitchValue1, PrevBinarySwitchValue1;
byte BinarySwitchValue2, PrevBinarySwitchValue2;
byte BinarySwitchValue3, PrevBinarySwitchValue3;
byte BinarySwitchValue4, PrevBinarySwitchValue4;
byte BinarySwitchValue5, PrevBinarySwitchValue5;
byte BinarySwitchValue6, PrevBinarySwitchValue6;
byte BinarySwitchValue7, PrevBinarySwitchValue7;

ZUNO_SETUP_CHANNELS(
  ZUNO_SWITCH_BINARY(BinarySwitchValue1, NULL),
  ZUNO_SWITCH_BINARY(BinarySwitchValue2, NULL),
  ZUNO_SWITCH_BINARY(BinarySwitchValue3, NULL),
  ZUNO_SWITCH_BINARY(BinarySwitchValue4, NULL),
  ZUNO_SWITCH_BINARY(BinarySwitchValue5, NULL),
  ZUNO_SWITCH_BINARY(BinarySwitchValue6, NULL),
  ZUNO_SWITCH_BINARY(BinarySwitchValue7, NULL)
);

DWORD StartMs, DurationMs;
const int ReportingIntervalMs = 7000;
void setup()
{
  Serial.begin();
  StartMs = millis() - ReportingIntervalMs - 1;
}

void loop()
{

  if (PrevBinarySwitchValue1 != BinarySwitchValue1) {
    Serial.print("BinarySwitchValue1 Changed to: ");
    Serial.println(BinarySwitchValue1);
    PrevBinarySwitchValue1 = BinarySwitchValue1;
  }

  if (PrevBinarySwitchValue2 != BinarySwitchValue2) {
    Serial.print("BinarySwitchValue2 Changed to: ");
    Serial.println(BinarySwitchValue2);
    PrevBinarySwitchValue2 = BinarySwitchValue2;
  }

  if (PrevBinarySwitchValue3 != BinarySwitchValue3) {
    Serial.print("BinarySwitchValue3 Changed to: ");
    Serial.println(BinarySwitchValue3);
    PrevBinarySwitchValue3 = BinarySwitchValue3;
  }
  if (PrevBinarySwitchValue4 != BinarySwitchValue4) {
    Serial.print("BinarySwitchValue4 Changed to: ");
    Serial.println(BinarySwitchValue4);
    PrevBinarySwitchValue4 = BinarySwitchValue4;
  }

  if (PrevBinarySwitchValue5 != BinarySwitchValue5) {
    Serial.print("BinarySwitchValue5 Changed to: ");
    Serial.println(BinarySwitchValue5);
    PrevBinarySwitchValue5 = BinarySwitchValue5;
  }

  if (PrevBinarySwitchValue6 != BinarySwitchValue6) {
    Serial.print("BinarySwitchValue6 Changed to: ");
    Serial.println(BinarySwitchValue6);
    PrevBinarySwitchValue6 = BinarySwitchValue6;
  }

  if (PrevBinarySwitchValue7 != BinarySwitchValue7) {
    Serial.print("BinarySwitchValue7 Changed to: ");
    Serial.println(BinarySwitchValue7);
    PrevBinarySwitchValue7 = BinarySwitchValue7;
  }

  DurationMs = millis() - StartMs;

  if (DurationMs > ReportingIntervalMs) {
    StartMs = millis();
    BinarySwitchValue1 = (BinarySwitchValue1 == 0x00) ? 0xFF : 0x00;
    zunoSendReport(1);
    delay(500);
    BinarySwitchValue2 = (BinarySwitchValue2 == 0x00) ? 0xFF : 0x00;
    zunoSendReport(2);
    delay(500);
    BinarySwitchValue3 = (BinarySwitchValue3 == 0x00) ? 0xFF : 0x00;
    zunoSendReport(3);
    delay(500);
    BinarySwitchValue4 = (BinarySwitchValue4 == 0x00) ? 0xFF : 0x00;
    zunoSendReport(4);
    delay(500);
    BinarySwitchValue5 = (BinarySwitchValue5 == 0x00) ? 0xFF : 0x00;
    zunoSendReport(5);
    delay(500);
    BinarySwitchValue6 = (BinarySwitchValue6 == 0x00) ? 0xFF : 0x00;
    zunoSendReport(6);
    delay(500);
    BinarySwitchValue7 = (BinarySwitchValue7 == 0x00) ? 0xFF : 0x00;
    zunoSendReport(7);
    delay(500);
  }
}
